// إå
#include <string.h>

#include <AttackEntry.H>
#include <Enemy.H>

// ----------------------------------------------------------------
// Υѥ
// ----------------------------------------------------------------

// ץȥ
void attackEnemy1(int, const AttackParam []);
void attackEnemy1a(int, const AttackParam []);
void attackEnemy2(int, const AttackParam []);
void attackEnemy3(int, const AttackParam []);
void attackEnemy4(int, const AttackParam []);
void attackEnemy4a(int, const AttackParam []);
void attackEnemyI(int, const AttackParam []);
void attackEnemyII(int, const AttackParam []);
void attackEnemyIII(int, const AttackParam []);
void attackEnemyIIIa(int, const AttackParam []);
void attackEnemyIV(int, const AttackParam []);
void attackRock(int, const AttackParam []);

// ȥ
struct AttackEntry attackEntry[] = {
    { "Rock",		attackRock,		1,	4 },
    { "Enemy1",		attackEnemy1,		1,	1 },
    { "Enemy1a",	attackEnemy1a,		2,	2 },
    { "Enemy2",		attackEnemy2,		1,	1 },
    { "Enemy3",		attackEnemy3,		2,	2 },
    { "Enemy4",		attackEnemy4,		1,	5 },
    { "Enemy4a",	attackEnemy4a,		1,	9 },    
    { "EnemyI",		attackEnemyI,		1,	1 },
    { "EnemyII",	attackEnemyII,		1,	1 },
    { "EnemyIII",	attackEnemyIII,		1,	1 },
    { "EnemyIIIa",	attackEnemyIIIa,	1,	1 },
    { "EnemyIV",	attackEnemyIV,		1,	1 },
    { NULL,		NULL,			0,	0 },
};

// enemy1
void attackEnemy1(int, const AttackParam argv[]) {
    const double y = argv[0].value;
    if (y < viewSize.y / 2) {
	for (int i = 0; i < 4; i ++)
	  new Enemy1(fps / 4 * i, DVector(viewSize.x + 32, y - 4 * i));
    } else if (y == viewSize.y / 2) {
	for (int i = 0; i < 4; i ++)
	  new Enemy1(fps / 4 * i, DVector(viewSize.x + 32, y));
    } else {
	for (int i = 0; i < 4; i ++)
	  new Enemy1(fps / 4 * i, DVector(viewSize.x + 32, y + 4 * i));
    }
}

// enemy1a
void attackEnemy1a(int, const AttackParam argv[]) {
    for (int i = 0; i < 4; i ++) {
	int v = (argv[1].value < viewSize.y / 2) ? 12 : -12;
	new Enemy1a(fps / 4 * i,
		   DVector(argv[0].value + 32 * i,
			   argv[1].value + v * i));
    }
}

// enemy2
void attackEnemy2(int, const AttackParam argv[]) {
    for (int i = 0; i < 4; i ++) {
	new Enemy2(fps / 4 * i,
		   DVector(viewSize.x + 32, argv[0].value));
    }
}

// enemy3
void attackEnemy3(int, const AttackParam argv[]) {
    for (int i = 0; i < 4; i ++) {
	int v = (argv[1].value < viewSize.y / 2) ? 12 : -12;
	new Enemy3(fps / 4 * i,
		   DVector(argv[0].value + 32 * i,
			   argv[1].value + v * i));
    }
}

// enemy4
void attackEnemy4(int argc, const AttackParam argv[]) {
    int n = int(argv[0].value);
    int f = (2 <= argc) ? int(argv[1].value) : 2;
    int t = (3 <= argc) ? int(argv[2].value) : 0;
    int b = (4 <= argc) ? int(argv[3].value) : int(viewSize.y);
    int r = (5 <= argc) ? int(argv[4].value) : fps * 3 / 2;
    for (int i = 0; i < n; i ++) {
	new Enemy4(i * f, r,
		   DVector(viewSize.x + 32, t + localRand(b - t)),
		   DVector(-6,0));
    }
}

// enemy4a
void attackEnemy4a(int argc, const AttackParam argv[]) {
    int f = int(argv[0].value);
    int i = 1;
    while (i < argc) {
	new Enemy4(i * f, fps * 3 / 2,
		   DVector(viewSize.x + 32, argv[i].value),
		   DVector(-6,0));
	i ++;
    }
}

// enemyI
void attackEnemyI(int, const AttackParam argv[]) {
    new EnemyI(DVector(viewSize.x + 64, argv[0].value));
}

// enemyII
void attackEnemyII(int, const AttackParam argv[]) {
    new EnemyII(DVector(viewSize.x + 64, argv[0].value));
}

// enemyIII
void attackEnemyIII(int, const AttackParam argv[]) {
    new EnemyIII(DVector(viewSize.x + 64, argv[0].value));
}

// enemyIIIa
void attackEnemyIIIa(int, const AttackParam argv[]) {
    new EnemyIIIa(DVector(viewSize.x + 64, argv[0].value));
}

// enemyIV
void attackEnemyIV(int, const AttackParam argv[]) {
    new EnemyIV(DVector(viewSize.x + 64, argv[0].value));
}

// rock
void attackRock(int argc, const AttackParam argv[]) {
    int n = int(argv[0].value);
    int f = (2 <= argc) ? int(argv[1].value) : 2;
    int t = (3 <= argc) ? int(argv[2].value) : 0;
    int b = (4 <= argc) ? int(argv[3].value) : int(viewSize.y);
    for (int i = 0; i < n; i ++) {
	new Rock(i * f , DVector(viewSize.x + 32, t + localRand(b - t)));
    }
}
