#ifndef Rank_H
#define Rank_H

// Ranking module
// 1st written by Shigeki Itoh 96/??/??
// rewritten by Taizo YAMAMOTO 98/03/06

// header
#include <stdio.h>
#include <String.h>

#include <List.H>

/* ##################################################
   Rank
   ################################################## */

class Rank {

    Rank(const String & = "NoName", const int = 0);
    Rank(const Rank &);
public:
    const Rank &operator = (const Rank &);
    
    String name;
    int score;

    static void load(const String &);
    static void add(const String &, const String &, const int);
    static void save(const String &);    
    static const Rank &get(const int);

    static const int max;
    
private:
    static void _load(FILE *);
    static void _save(FILE *);    
    static void _add(const String &, const int);    
    static Rank rank[];
    
};

#endif Rank_H

