#ifndef Ship_H
#define Ship_H

// header
#include <common.H>

#include <Obj.H>
#include <Sprite.H>

/* ##################################################################
   Ship-Viper
   ################################################################## */

#define MISSILE_FULL_NUM 2

class ShipViper : public Ship {

  public:
    ShipViper(const DVector & = dzero);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);

    int useMainWeapon(void);
    int useSubWeapon(void);
    int addSubWeapon(void);
    
  protected:
    Sprite missileSp[MISSILE_FULL_NUM];	// missileΥɽ
    
};

#endif
