// header
#include <Sprite.H>

/* ########################################################
   Sprite
   ######################################################## */

Sprite::Sprite(const XsImage *i, const DVector &l, const double d, int s) : XsSprite(::view, i, l, d, s) {}

void Sprite::set(const XsImage *i, const DVector &l, const double d,  int s) {
    image = i;
    locate = l;
    depth = d;
    state = s;
}

/* ########################################################
   Text
   ######################################################## */

Text::Text(const String &s, const DVector &l, const double d, int a, const XsFont &f, int i) : XsText(s, a, f), XsSprite(::view, (XsText *)this, l, d, i) {}

void Text::set(const String &s, const DVector &l, const double d, int a, const XsFont &f, int i) {
    text(s);
    font(f);
    anchor(a);
    locate = l;
    XsSprite::depth = d;
    state = i;
}



