// إå
#include <iomanip.h>
#include <stdlib.h>

#include <common.H>

// äΥե졼
const int fps = 20;

// صؿ
const int localRand(const int m) {
    if (0 <= m) {
	return (rand() / 256) % m;
    } else {
	return - (rand() / 256) % m;
    }
}

// 
XsKey quitKey(XK_q);
XsKey pauseKey(XK_p);
XsKey stepKey(XK_o);
XsKey upKey(XK_i);
XsKey downKey(XK_k);
XsKey rightKey(XK_l);
XsKey leftKey(XK_j);
XsKey triggerKey(XK_f);
XsKey trigger2Key(XK_d);

// 礭
const DVector tileSize(24, 24);
const DVector mapSize(21, 14);
const DVector viewSize(tileSize * mapSize);

// ɥ
XsWindow window(viewSize,"XImpact",0);

// ӥ塼
XsView view(window,tileSize,1);

// ȥ
const XsFont common18Fn("-adobe-helvetica-bold-o-normal--18-*-*-*-*-*-*-*");
const XsFont common14Fn("-adobe-helvetica-bold-o-normal--14-*-*-*-*-*-*-*");

// ԥåޥå
const XsPixmap backPx[] = {
    XsPixmap(IMAGEDIR "/star-24x24.xpm"),
    XsPixmap(IMAGEDIR "/star2-24x24.xpm"),
    XsPixmap(IMAGEDIR "/star3-24x24.xpm"),
    XsPixmap(IMAGEDIR "/star4-24x24.xpm"),
    XsPixmap(IMAGEDIR "/back-24x24.xpm"),
    XsPixmap(IMAGEDIR "/back2-24x24.xpm"),
};
const XsPixmap shipPx(IMAGEDIR "/ship-40x24.xpm");
const XsPixmap iconPx[] = {
    XsPixmap(IMAGEDIR "/ship-28x16.xpm"),
    XsPixmap(IMAGEDIR "/shipmissile-24x12.xpm"),
    XsPixmap(IMAGEDIR "/shipmissile-full-36x16.xpm"),    
};
const XsPixmapRound shipMissilePxRn[] = {
    XsPixmapRound(IMAGEDIR "/shipmissile-16x16.xpm",36),
    XsPixmapRound(IMAGEDIR "/shipmissile2-16x16.xpm",36),    
};
const XsPixmapRound enemyMissilePxRn[] = {
    XsPixmapRound(IMAGEDIR "/enemymissile-16x16.xpm",36),
    XsPixmapRound(IMAGEDIR "/enemymissile2-16x16.xpm",36),
};
const XsPixmapRound enemyShellPxRn(IMAGEDIR "/enemyshell-8x8.xpm",36);
const XsPixmapRound rockPxRn[] = {
    XsPixmapRound(IMAGEDIR "/rock-32x32.xpm",6),
    XsPixmapRound(IMAGEDIR "/rock-24x24.xpm",6),
};
const XsPixmap lightPx[] = {
    XsPixmap(IMAGEDIR "/light-48x48.xpm"),
    XsPixmap(IMAGEDIR "/light-44x44.xpm"),
    XsPixmap(IMAGEDIR "/light-40x40.xpm"),
    XsPixmap(IMAGEDIR "/light-36x36.xpm"),
    XsPixmap(IMAGEDIR "/light-32x32.xpm"),
    XsPixmap(IMAGEDIR "/light-28x28.xpm"),
    XsPixmap(IMAGEDIR "/light-24x24.xpm"),
    XsPixmap(IMAGEDIR "/light-20x20.xpm"),
    XsPixmap(IMAGEDIR "/light-16x16.xpm"),
};
const XsPixmap laser0Px[] = {
    XsPixmap(IMAGEDIR "/rightlaser-8x8.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-12x12.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-16x16.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-512x16.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-512x14.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-512x12.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-512x10.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-512x8.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-512x6.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-512x4.xpm"),
    XsPixmap(IMAGEDIR "/rightlaser-512x2.xpm"),
};
const XsPixmap laser1Px[] = {
    XsPixmap(IMAGEDIR "/downlaser-8x8.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-12x12.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-16x16.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-16x512.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-14x512.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-12x512.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-10x512.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-8x512.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-6x512.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-4x512.xpm"),
    XsPixmap(IMAGEDIR "/downlaser-2x512.xpm"),
};
const XsPixmap laser2Px[] = {
    XsPixmap(IMAGEDIR "/leftlaser-8x8.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-12x12.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-16x16.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-512x16.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-512x14.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-512x12.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-512x10.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-512x8.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-512x6.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-512x4.xpm"),
    XsPixmap(IMAGEDIR "/leftlaser-512x2.xpm"),
};
const XsPixmap laser3Px[] = {
    XsPixmap(IMAGEDIR "/uplaser-8x8.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-12x12.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-16x16.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-16x512.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-14x512.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-12x512.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-10x512.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-8x512.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-6x512.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-4x512.xpm"),
    XsPixmap(IMAGEDIR "/uplaser-2x512.xpm"),
};

const XsPixmapRound enemy1PxRn[2] = {
    XsPixmapRound(IMAGEDIR "/enemy1-fore-32x32.xpm",36),
    XsPixmapRound(IMAGEDIR "/enemy1-back-44x44.xpm",36),
};
const XsPixmap enemy2Px(IMAGEDIR "/enemy2-40x24.xpm");
const XsPixmapRound enemy3PxRn(IMAGEDIR "/enemy3-24x24.xpm",36);
const XsPixmapRound enemy4PxRn(IMAGEDIR "/enemy4-32x32.xpm",36);

const XsPixmap enemyIPx[3] = {
    XsPixmap(IMAGEDIR "/enemyI-body-40x24.xpm"),
    XsPixmap(IMAGEDIR "/enemyI-pod-40x24.xpm"),
    XsPixmap(IMAGEDIR "/enemyI-gun-40x24.xpm")
};
const XsPixmapRound enemyIIPxRn[3] = {
    XsPixmapRound(IMAGEDIR "/enemyII-gun-40x40.xpm",36),	
    XsPixmapRound(IMAGEDIR "/enemyII-up-40x40.xpm",36),
    XsPixmapRound(IMAGEDIR "/enemyII-down-40x40.xpm",36),
};
const XsPixmapRound enemyIIIPxRn[] = {
    XsPixmapRound(IMAGEDIR "/enemyIII-32x32.xpm",36),
    XsPixmapRound(IMAGEDIR "/enemyIII-pack-32x32.xpm",36),
};
const XsPixmap enemyIVPx(IMAGEDIR "/enemyIV-64x64.xpm");
