//
// ٥饹
//

// إå
#include <DVector.H>

// Ū
const DVector dzero(0,0);
double DVector::max = 360;

// ᥽å
ostream &operator<<(ostream &out,const DVector &vec) {
    out << "(" << vec.x << "," << vec.y << ")";
    return out;
}
// дؿ
DVector::DVector(const double xx,const double yy) : x(xx),y(yy) {
}
DVector::DVector(const DVector &v) : x(v.x),y(v.y) {
}
DVector::DVector(const Vector &v) : x(double(v.x)),y(double(v.y)) {
}
int DVector::in(const DVector &vec) const {
    if (x < 0 || vec.x <= x || y < 0 || vec.y <= y) {
	return 0;
    } else {
	return 1;
    }
}
const DVector &DVector::operator=(const DVector &vec) {
    x = vec.x;
    y = vec.y;
    return *this;
}
const DVector DVector::operator+(void) const {
    return DVector(x, y);
}
const DVector DVector::operator-(void) const {
    return DVector(-x, -y);
}
int DVector::operator==(const DVector &vec) const {
    return (x == vec.x) && (y == vec.y);
}
int DVector::operator!=(const DVector &vec) const {
    return (x != vec.x) || (y != vec.y);
}
const DVector DVector::operator+(const DVector &vec) const {
    return DVector(x + vec.x, y + vec.y);
}
const DVector DVector::operator-(const DVector &vec) const {
    return DVector(x - vec.x, y - vec.y);
}
const DVector DVector::operator*(const DVector &vec) const {
    return DVector(x * vec.x, y * vec.y);
}
const DVector DVector::operator/(const DVector &vec) const {
    return DVector(x / vec.x, y / vec.y);
}
const DVector DVector::operator*(const double a) const {
    return DVector(x * a, y * a);
}
const DVector DVector::operator/(const double a) const {
    return DVector(x / a, y / a);
}
const DVector DVector::operator%(const double r) const {
    double s = sin((r*2*M_PI)/max);    
    double c = cos((r*2*M_PI)/max);    
    return DVector(x * c - y * s,x * s + y * c);
}
const DVector &DVector::operator+=(const DVector &vec) {
    *this = *this + vec;
    return  *this;
}
const DVector &DVector::operator-=(const DVector &vec) {
    *this = *this - vec;
    return  *this;
}
const DVector &DVector::operator*=(const DVector &vec) {
    *this = *this * vec;
    return  *this;
}
const DVector &DVector::operator/=(const DVector &vec) {
    *this = *this / vec;
    return  *this;
}
const DVector &DVector::operator*=(const double a) {
    *this = *this * a;
    return  *this;
}
const DVector &DVector::operator/=(const double a) {
    *this = *this / a;
    return  *this;
}
const DVector &DVector::operator%=(const double r) {
    *this = *this % r;
    return  *this;
}
