#ifndef DVector_H
#define DVector_H

//
// ٥٥饹
//

// إå
#include <math.h>
#include <stream.h>
#include <Vector.H>

class Vector;
class DVector;
extern const DVector dzero;
ostream &operator<<(ostream &,const DVector &);
class DVector {
    
  public:
    DVector(const double x = 0,
	    const double y = 0);
    DVector(const DVector &);
    DVector(const Vector &);
    
    double x;
    double y;

    static double max;

    int in(const DVector &) const;

    const DVector &operator=(const DVector &);
    
    const DVector operator+(void) const;
    const DVector operator-(void) const;
    
    int operator==(const DVector &) const;
    int operator!=(const DVector &) const;
    
    const DVector operator+(const DVector &) const;
    const DVector operator-(const DVector &) const;
    const DVector operator*(const DVector &) const;
    const DVector operator/(const DVector &) const;
    const DVector operator*(const double) const;
    const DVector operator/(const double) const;
    const DVector operator%(const double) const;

    const DVector &operator+=(const DVector &);
    const DVector &operator-=(const DVector &);
    const DVector &operator*=(const DVector &);
    const DVector &operator/=(const DVector &);
    const DVector &operator*=(const double);
    const DVector &operator/=(const double);
    const DVector &operator%=(const double);
};

#endif
