#ifndef Vector_H
#define Vector_H

//
// ٥饹
//

// إå
#include <math.h>
#include <stream.h>
#include <DVector.H>

// Х٥ȥ롼סüʤ
#define ForAbs(a,b,c)		for (Vector a = b; a.y < c.y; a.y++) \
				for (a.x = b.x; a.x < c.x; a.x++)
     
#define ForAbsOuter(a,b,c)	for (Vector a = b; a.y < c.y; a.y++)
#define ForAbsInner(a,b,c)	for (a.x = b.x; a.x < c.x; a.x++)
// Х٥ȥ롼סü
#define ForAbsE(a,b,c)		for (Vector a = b; a.y <= c.y; a.y++) \
				for (a.x = b.x; a.x <= c.x; a.x++)
     
#define ForAbsEOuter(a,b,c)	for (Vector a = b; a.y <= c.y; a.y++)
#define ForAbsEInner(a,b,c)	for (a.x = b.x; a.x <= c.x; a.x++)
// Х٥ȥ롼סüʤ
#define ForRel(a,b,c)		for (Vector a = b; a.y < b.y + c.y; a.y++) \
				for (a.x = b.x; a.x < b.x + c.x; a.x++)
     
#define ForRelOuter(a,b,c)	for (Vector a = b; a.y < b.y + c.y; a.y++)
#define ForRelInner(a,b,c)	for (a.x = b.x; a.x < b.x + c.x; a.x++)
// Х٥ȥ롼סü
#define ForRelE(a,b,c)		for (Vector a = b; a.y <= b.y + c.y; a.y++) \
				for (a.x = b.x; a.x <= b.x + c.x; a.x++)
     
#define ForRelEOuter(a,b,c)	for (Vector a = b; a.y <= b.y + c.y; a.y++)
#define ForRelEInner(a,b,c)	for (a.x = b.x; a.x <= b.x + c.x; a.x++)

class DVector;
class Vector;
extern const Vector zero;
ostream &operator<<(ostream &,const Vector &);
const Vector max(const Vector &,const Vector &);
const Vector min(const Vector &,const Vector &);
const Vector sign(const Vector &,const Vector &);
class Vector {
    
  public:
    Vector(const int x = 0,
	   const int y = 0);
    Vector(const Vector &);
    Vector(const DVector &);

    int in(const Vector &) const;
    
    int x;
    int y;

    const Vector &operator=(const Vector &);

    const Vector operator+(void) const;
    const Vector operator-(void) const;
    
    int operator==(const Vector &) const;
    int operator!=(const Vector &) const;
    
    const Vector operator+(const Vector &) const;
    const Vector operator-(const Vector &) const;
    const Vector operator*(const Vector &) const;
    const Vector operator/(const Vector &) const;
    const Vector operator*(const int) const;
    const Vector operator/(const int) const;

    const Vector &operator+=(const Vector &);
    const Vector &operator-=(const Vector &);
    const Vector &operator*=(const Vector &);
    const Vector &operator/=(const Vector &);
    const Vector &operator*=(const int);
    const Vector &operator/=(const int);
};

#endif
