// إå
#include <XsBox.H>

//
// XsBox.C
//

XsBox::XsBox(const XsColor &c,
		 const Vector &s,
		 const Vector &h)
: XsSolid(s,h),pixel(c.color.pixel),oldpixel(0) {}

XsBox::~XsBox(void) {}

void XsBox::draw(const XsPixmap &p,const Vector &v) const {

    int xx = v.x - _hots.x;
    int yy = v.y - _hots.y;
     
    XSetForeground(display,gc,pixel);
    XFillRectangle(display,p.pixmap(),gc,
		   xx,yy,_size.x,_size.y);
}

// 
int XsBox::isChanged(void) const {

    return (oldpixel != pixel ||
	    XsImage::isChanged());
}

void XsBox::flushImage(void) {

    oldpixel = pixel;
    XsImage::flushImage();
}
