//
// XsKey.C
//

// إå
#include <XsKey.H>

// Ū
char XsKey::keyVector[32];
char XsKey::keyVectorOld[32];

// 󥹥ȥ饯
XsKey::XsKey(KeySym keysym) {

    // å
    KeyCode keycode = XKeysymToKeycode(display,keysym);
    if (keycode == NoSymbol) {
	cerr << "ERROR !!! : Don't specify keycode NoSymbol." << endl;
	exit(1);
    }
    byteIndex = (keycode / 8);
    bitIndex = (keycode & 7);
}

// Υåץǡ
void XsKey::flushAllKey(void) {

    // Υ٥¸
    memcpy(keyVectorOld,keyVector,32);

    // ٥μ
    XQueryKeymap(display,keyVector);
}

// ֤μ
int XsKey::is(void) { return ((keyVector[byteIndex] >> bitIndex) & 1); }
int XsKey::was(void) { return ((keyVectorOld[byteIndex] >> bitIndex) & 1); }
int XsKey::isPressed(void) { return is() & !was(); }
int XsKey::isReleased(void) { return !is() & was(); }


