// إå
#include <XsLine.H>

//
// XsLine.C
//

/* ##############################################################
   class XsLine
   ############################################################## */

// 󥹥ȥ饯
XsLine::XsLine(const XsColor &c,
	       const Vector &s,
	       const Vector &h)
: XsImage(s,h),pixel(c.color.pixel),oldpixel(0) {}

// ǥȥ饯
XsLine::~XsLine(void) {}

// 
void XsLine::draw(const XsPixmap &p,const Vector &v) const {

    int xx = v.x - _hots.x;
    int yy = v.y - _hots.y;
     
    XSetForeground(display,gc,pixel);
    XDrawLine(display,p.pixmap(),gc,
	      xx,yy,xx+_size.x,yy+_size.y);
}

// λ
void XsLine::color(const XsColor &c) {

    pixel = c.color.pixel;
}

// ü
Vector &XsLine::terminal(void) {
    return _size;
}

const Vector XsLine::top(void) const {
    return min(-_hots,_size-_hots);
}

const Vector XsLine::bottom(void) const {
    return max(-_hots,_size-_hots);    
}

// 줿
int XsLine::isChanged(void) const {

    return (oldpixel != pixel ||
	    XsImage::isChanged());
}

// 
void XsLine::flushImage(void) {

    oldpixel = pixel;
    XsImage::flushImage();
}
