#ifndef XsSprite_H
#define XsSprite_H

//
// XsSprite.H
//

// إå
#include <XsImage.H>
#include <XsView.H>
#include <DVector.H>

// 饹
class XsView;
class XsSprite : public XsBase {
    
friend class XsView;
    
  public:
    XsSprite(XsView &, const XsImage *,
	     const DVector & = zero,
	     const double = 0,
	     const int = 0);
    XsSprite(const XsSprite &);
    ~XsSprite(void);

    // 
  public:
    DVector locate;
    const Vector top(void) const;
    const Vector bottom(void) const;
    
    int state;
    double depth;
  private:
    Vector oldlocate;
    Vector oldtop;
    Vector oldbottom;
    
    int oldstate;
    double olddepth;

    // XsViewκ
  public:
    const Vector mapTop(void) const;
    const Vector mapBottom(void) const;
    const Vector oldmapTop(void) const;
    const Vector oldmapBottom(void) const;
    
    // View & Image
  public:
    XsView &view;
    const XsImage *image;
  private:
    const XsImage *oldimage;

    // ...
  private:
    void flushSprite(void);
    int mustDrawBack(void) const;
    int mustDraw(void) const;
};

#endif
