#ifndef Game_H
#define Game_H

// header
#include <fstream.h>
#include <String.h>

#include <DVector.H>
#include <XsSprite.H>
#include <List.H>

#include <common.H>
#include <State.H>
#include <Sprite.H>

/* ##################################################################
   Game
   ################################################################## */

#define SHIP_NUM 3

class Game : public State {

  public:
    Game(void);			// 󥹥ȥ饯
    ~Game(void);		// ǥȥ饯
    State *func(void);		// ֤ν

    void doStage(void);		// ơɤ߹߽
    void doOneStep(int, int);	// 1ƥå׿ʤ
    
    static Game *game(void);
  private:
    static Game *_game;

    // information
  public:
    int score;			// score
    int ship;			// ship
  protected:
    int rank;			// rank
    int _score;			// score
    Text scoreTxt;		// scoreΥƥ
    Text startTxt;		// startΥƥ
    Text pauseTxt;		// pauseΥƥ
    Text overTxt;		// overΥƥ
    Sprite shipSp[SHIP_NUM];	// shipΥɽ    
    
    // stage    
  protected:
    int stageNum;		// ơֹ
    const int stageMax;		// ǽơֹ
    enum PhaseGame {
	initofGame,
	start,
	play,
	step,
	pause,
	hit,
	over,
    } phaseGame;		// Υե
    int stepGame;		// 
    enum PhaseStage {
	initofStage,
	frame,
	second,
	enemy,
	message,
    } phaseStage;		// ơǡΥե
    int stepStage;		// 

  private:
    ifstream *stageStream;	// ơǡΥȥ꡼
    String file; 		// ե̾
    int line;			// եιԿ
};

#endif


















