#ifndef common_H
#define common_H

/* ##################################################################
   ΰ
   ################################################################## */

// header
#include <stream.h>

#include <Vector.H>
#include <XsKey.H>
#include <XsWindow.H>
#include <XsView.H>
#include <XsPixmap.H>
#include <XsPixmapRound.H>
#include <XsPixmapTrans.H>
#include <XsText.H>

// macro
#ifndef XITOPDIR
#define XITOPDIR	"./"
#endif

#define IMAGEDIR	XITOPDIR "/image/"
#define STAGEDIR	XITOPDIR "/stage/"
#define SCOREDIR	XITOPDIR "/score/"

#define STAGEFILE	STAGEDIR "/stage%d.dat"
#define SCOREFILE	SCOREDIR "/score"

// depth
enum {
    DEPTH_BACK,
    DEPTH_ENEMY_BACK,
    DEPTH_ENEMY,
    DEPTH_ENEMY_FRONT,
    DEPTH_SHIP,
    DEPTH_ENEMY_ATTACK,
    DEPTH_SHIP_ATTACK,
    DEPTH_FRONT,
    DEPTH_FRAME,
};

// äΥե졼
extern const int fps;

// صؿ
extern const int localRand(const int);

// 
extern XsKey quitKey;
extern XsKey pauseKey;
extern XsKey stepKey;
extern XsKey upKey;
extern XsKey downKey;
extern XsKey rightKey;
extern XsKey leftKey;
extern XsKey triggerKey;
extern XsKey trigger2Key;

// Ƽ礭
extern const DVector tileSize;
extern const DVector mapSize;
extern const DVector viewSize;

// ɥ
extern XsWindow window;

// ӥ塼
extern XsView view;

// ȥ
extern const XsFont common18Fn;
extern const XsFont common14Fn;

// ԥåޥå
extern const XsPixmap backPx[];
extern const XsPixmap lightPx[];

extern const XsPixmap iconPx[];

extern const XsPixmapRound shipMissilePxRn[];
extern const XsPixmapRound enemyMissilePxRn[];
extern const XsPixmapRound enemyShellPxRn;

extern const XsPixmap laser0Px[];
extern const XsPixmap laser1Px[];
extern const XsPixmap laser2Px[];
extern const XsPixmap laser3Px[];

extern const XsPixmap shipPx;

extern const XsPixmapRound rockPxRn[];

extern const XsPixmapRound enemy1PxRn[];
extern const XsPixmapRound enemy1backPxRn;
extern const XsPixmap enemy2Px;
extern const XsPixmapRound enemy3PxRn;
extern const XsPixmapRound enemy4PxRn;

extern const XsPixmap enemyIPx[];
extern const XsPixmapRound enemyIIPxRn[];
extern const XsPixmapRound enemyIIIPxRn[];
extern const XsPixmap enemyIVPx;

#endif

