//
// ٥饹
//

// إå
#include <Vector.H>

// Ū
const Vector zero(0,0);

// ᥽å
ostream &operator<<(ostream &out,const Vector &vec) {
    out << "(" << vec.x << "," << vec.y << ")";
    return out;
}
const Vector min(const Vector &vec1,const Vector &vec2) {
    return Vector ((vec1.x < vec2.x) ? vec1.x : vec2.x,
		   (vec1.y < vec2.y) ? vec1.y : vec2.y);
}
const Vector max(const Vector &vec1,const Vector &vec2) {
    return Vector ((vec1.x > vec2.x) ? vec1.x : vec2.x,
		   (vec1.y > vec2.y) ? vec1.y : vec2.y);
}
const Vector sign(const Vector &vec1,const Vector &vec2) {
    Vector tmp;
    if (vec2.x-vec1.x > 0)
      tmp.x = 1;
    else if (vec2.x-vec1.x < 0)
      tmp.x = -1;
    if (vec2.y-vec1.y > 0)
      tmp.y = 1;
    else if (vec2.y-vec1.y < 0)
      tmp.y = -1;
    return tmp;
}
// дؿ
Vector::Vector(const int xx,const int yy) : x(xx),y(yy) {
}
Vector::Vector(const Vector &v) : x(v.x),y(v.y) {
}
Vector::Vector(const DVector &dv) : x(int(dv.x)),y(int(dv.y)) {
}
int Vector::in(const Vector &vec) const {
    if (x < 0 || vec.x <= x || y < 0 || vec.y <= y) {
	return 0;
    } else {
	return 1;
    }
}
const Vector &Vector::operator=(const Vector &vec) {
    x = vec.x;
    y = vec.y;
    return *this;
} 
const Vector Vector::operator+(void) const {
    return Vector(x, y);
}
const Vector Vector::operator-(void) const {
    return Vector(-x, -y);
}
int Vector::operator==(const Vector &vec) const {
    return (x == vec.x) && (y == vec.y);
}
int Vector::operator!=(const Vector &vec) const {
    return (x != vec.x) || (y != vec.y);
}
const Vector Vector::operator+(const Vector &vec) const {
    return Vector(x + vec.x, y + vec.y);
}
const Vector Vector::operator-(const Vector &vec) const {
    return Vector(x - vec.x, y - vec.y);
}
const Vector Vector::operator*(const Vector &vec) const {
    return Vector(x * vec.x, y * vec.y);
}
const Vector Vector::operator/(const Vector &vec) const {
    return Vector(x / vec.x, y / vec.y);
}
const Vector Vector::operator*(const int a) const {
    return Vector(x * a, y * a);
}
const Vector Vector::operator/(const int a) const {
    return Vector(x / a, y / a);
}
const Vector &Vector::operator+=(const Vector &vec) {
    *this = *this + vec;
    return  *this;
}
const Vector &Vector::operator-=(const Vector &vec) {
    *this = *this - vec;
    return  *this;
}
const Vector &Vector::operator*=(const Vector &vec) {
    *this = *this * vec;
    return  *this;
}
const Vector &Vector::operator/=(const Vector &vec) {
    *this = *this / vec;
    return  *this;
}
const Vector &Vector::operator*=(const int a) {
    *this = *this * a;
    return  *this;
}
const Vector &Vector::operator/=(const int a) {
    *this = *this / a;
    return  *this;
}
