#ifndef XsBase_H
#define XsBase_H

//
// XsBase.H
//

// إå
#include <stream.h>
#include <X11/Xlib.h>

#include <Vector.H>

/* ###################################################################
   class XsBase
   쥯饹
   ################################################################### */

// 饹
class XsBase {

    /* friend 饹 */
friend class XsBaseInit;
    
    /* ۡ˲ */
  public:
    XsBase(void);			// 󥹥ȥ饯
    ~XsBase(void);			// ǥȥ饯
  private:
    static void construct(void);	// ŪФν
    static void destruct(void);		// ŪФβ
    
    /* Ūǡ */
  protected:
    static Display * display;
    static XEvent event;
    static Window root;
    static int screen;
    static int depth;
    static int displayWidth;
    static int displayHeight;
    static unsigned long black;
    static unsigned long white;
    static Visual * visual;
    static Colormap colorMap;
    static GC gc;	// for all plane
    static GC gcCopy;
    static GC gcStippled;
    static GC gcAnd;
    static GC gcOr;
    static GC gcWhite;
    static GC gcBlack;
    static GC gc1;	// for only one plane
    static GC gc1Copy;
    static GC gc1Stippled;
    static GC gc1And;
    static GC gc1Or;
    static GC gc1White;
    static GC gc1Black;
};

/* ###################################################################
   class XsBaseInit
   쥯饹饹
   ################################################################### */

// 饹
class XsBaseInit {
    static int counter;
  public:
    XsBaseInit(void);
    ~XsBaseInit(void);
};

// 
static XsBaseInit xsBaseInitCounter;

#endif
