#ifndef XsBox_H
#define XsBox_H

//
// XsBox.H
//

// إå
#include <X11/xpm.h>
#include <XsImage.H>
#include <XsSolid.H>
#include <XsPixmap.H>
#include <XsColor.H>

// 饹
class XsBox : public XsSolid {

  public:
    XsBox(const XsColor &,const Vector &,const Vector & = zero);
    ~XsBox(void);

    
public:
    virtual void draw(const XsPixmap &, const Vector &) const;
    virtual int isChanged(void) const;
    virtual void flushImage(void);

  private:
    unsigned long pixel;
    unsigned long oldpixel;
};

#endif
