//
// XsColor.C
//

// إå
#include <XsColor.H>

// Ū
unsigned long XsColor::planeMask;
const XsColor XsColor::defaultWhite(0xffff,0xffff,0xffff);
const XsColor XsColor::defaultBlack(0x0000,0x0000,0x0000);

// 󥹥ȥ饯
XsColor::XsColor(const int r , const int g , const int b ) {

    color.red	= r;
    color.green	= g;
    color.blue	= b;
    color.flags	= DoRed|DoBlue|DoGreen;
    XAllocColor(display,colorMap,&color);
}

// ǥȥ饯
XsColor::~XsColor(void) {

    XFreeColors(display,colorMap,&color.pixel,1,planeMask);
}

// 
const unsigned short &XsColor::red(void) const {
    return color.red;
}
const unsigned short &XsColor::green(void) const {
    return color.green;
}
const unsigned short &XsColor::blue(void) const {
    return color.blue;
}
