#ifndef XsImage_H
#define XsImage_H

//
// XsImage.H
//

// إå
#include <XsBase.H>
#include <List.H>

// 饹
class XsPixmap;
class XsImage;

// ̥륤᡼
extern XsImage nullImage;

// 饹
class XsImage : public XsBase {

    /* ۡ˲ */
  public:
    XsImage(const Vector & = zero,
	    const Vector & = zero);	// 󥹥ȥ饯
    virtual ~XsImage(void);		// ǥȥ饯

    /*  */
  public:
    virtual void draw(const XsPixmap &,
		      const Vector &) const;
    virtual void draw(const XsPixmap &,
		      const Vector &,
		      const Vector &) const;

  public:
    virtual const Vector top(void) const;
    virtual const Vector bottom(void) const;

  public:
    virtual int isChanged(void) const;
    static void flushAllImage(void);
  protected:
    virtual void flushImage(void);
    
  public:
    static Set <XsImage *> set;

  public:
    const Vector &size(void) const;
    const Vector &hots(void) const;
  protected:
    Vector _size;
    Vector _hots;

  private:
    Vector oldsize;
    Vector oldhots;
};

#endif
