#ifndef XsLine_H
#define XsLine_H

//
// XsLine.H
//

// إå
#include <X11/xpm.h>
#include <XsImage.H>
#include <XsPixmap.H>
#include <XsColor.H>

// 饹
class XsLine : public XsImage {

  public:
    XsLine(const XsColor & = XsColor::defaultWhite,
	   const Vector & = zero,
	   const Vector & = zero);
    ~XsLine(void);

public:
    virtual void draw(const XsPixmap &, const Vector &) const;
    virtual int isChanged(void) const;
    virtual void flushImage(void);

public:
    void color(const XsColor &);
    Vector &terminal(void);
    virtual const Vector top(void) const;
    virtual const Vector bottom(void) const;

  private:
    unsigned long pixel;
    unsigned long oldpixel;
};

#endif
