// إå
#include <XsPixmapRound.H>

/* ###################################################################
   class XsPixmapRound
   ################################################################### */

// #define ON_RUNTIME

XsPixmapRound::XsPixmapRound(const String &f,int m) : XsPixmap(f),max(m),_image(NULL) {
#ifndef ON_RUNTIME
    round();
#endif
}

XsPixmapRound::XsPixmapRound(const XsPixmap &p,int m) : XsPixmap(p),max(m),_image(NULL) {
#ifndef ON_RUNTIME    
    round();
#endif
}

// ž
void XsPixmapRound::round(void) {

    /* ʬβ */
    delete [] _image;
    _image = new XsPixmap[max];

    /* ž */
    if (size().x != size().y) {
	cerr << "ERROR !!! : size is not valid." << endl;
	exit(1);
    }

    // ޥ¸ߤˤäƽؤ롥
    if (mask()) {

	// ޥͭ
	XImage *xsp;
	XImage *xsm;
	xsp = XGetImage(display, pixmap(),
			0, 0, size().x, size().y,
			AllPlanes, ZPixmap);
	xsm = XGetImage(display, mask(),
			0, 0, size().x, size().y,
			AllPlanes, ZPixmap);

	// ġΥԥåޥåפˤĤƲž
	for (int loop = 0;loop < max;loop ++) {

	    XsPixmap &i = _image[loop];
	    const double dd = DVector::max * loop / max;

	    // ԥåޥåפ礭η
	    i.create(size(),
		     (DVector(_hots) - DVector(_size) / 2) % dd
		     + DVector(_size) / 2);

	    // XImage¤Τμ
	    XImage *xdp;
	    XImage *xdm;
	    xdp = XGetImage(display, i.pixmap(),
			    0, 0,
			    i.size().x, i.size().y,
			    AllPlanes, ZPixmap);
	    xdm = XGetImage(display, i.mask(),
			    0, 0,
			    i.size().x, i.size().y,
			    AllPlanes, ZPixmap);
	    
	    // ž
	    DVector dcenter(DVector(_size) / 2 - DVector(0.5,0.5));
	    ForRel (l,zero,size()) {
		DVector ddp(l);
		DVector dsp((ddp - dcenter) % (- dd) + dcenter);
		Vector vsp(dsp);
		if (vsp.in(size())) {
		    XPutPixel(xdp,l.x,l.y,XGetPixel(xsp,vsp.x,vsp.y));
		    XPutPixel(xdm,l.x,l.y,XGetPixel(xsm,vsp.x,vsp.y));
		} else {
		    XPutPixel(xdp,l.x,l.y,0);
		    XPutPixel(xdm,l.x,l.y,0);
		}
	    }
	      
	    // ׻̤Υԡ
	    XPutImage(display, i.pixmap(),
		      gcCopy, xdp, 0, 0,
		      0, 0, size().x, size().y);
	    XPutImage(display, i.mask(),
		      gc1Copy, xdm, 0, 0,
		      0, 0, size().x, size().y);
	}
    } else {
	
	// ޥ̵
	XImage *xsp;
	xsp = XGetImage(display,pixmap(),
			0,0,size().x,size().y,
			AllPlanes,ZPixmap);

	// ġΥԥåޥåפˤĤƲž
	for (int loop = 0;loop < max;loop ++) {

	    XsPixmap &i = _image[loop];
	    const double dd = DVector::max * loop / max;
	    
	    // ԥåޥåפ礭η
	    i.create(size(),size()/2);

	    // XImage¤Τμ
	    XImage *xdp;
	    xdp = XGetImage(display, i.pixmap(),
			    0, 0,
			    i.size().x, i.size().y,
			    AllPlanes, ZPixmap);
	    
	    // ž
	    DVector dcenter(DVector(_size)/2);
	    ForRelOuter (l,zero,size()) {
		ForRelInner (l,zero,size()) {
		    DVector ddp(l);
		    DVector dsp((ddp - dcenter) % (- dd) + dcenter);
		    Vector vsp(dsp);
		    if (vsp.in(size())) {
			XPutPixel(xdp,l.x,l.y,XGetPixel(xsp,vsp.x,vsp.y));
		    } else {
			XPutPixel(xdp,l.x,l.y,0);
		    }
		}
	    }

	    // ׻̤Υԡ
	    XPutImage(display, i.pixmap(),
		      gcCopy,xdp,0,0,
		      0,0,size().x,size().y);
	}
    }

    XFlush(display);
}

XsPixmapRound::~XsPixmapRound(void) {
    delete [] _image;
    _image = NULL;
}

const XsPixmap &XsPixmapRound::image(const double d = 0) const {

    int n = int(d / 360);	// žη׻
    double rd = d - n * 360;	// 
    rd += (rd < 0) ? 360 : 0;	// ʤвû

#ifdef ON_RUNTIME    
    if (!_image) ((XsPixmapRound *)this)->round(); // ɬפʤн
#endif
    
    return _image[int(max * rd / 360)];
}

