// header
#include <stdlib.h>

#include <XsPixmapTrans.H>

/* ###########################################################
   class XsPixmapTrans
   ########################################################### */

static int defaultfunc(int, int, int l, int m) {
    return (l <= (rand() / 1024) % m);
}

XsPixmapTrans::XsPixmapTrans(const String &f, int m, int (*v)(int, int, int, int)) : XsPixmap(f), max(m), _image(NULL) {
    trans(v);
}

XsPixmapTrans::XsPixmapTrans(const XsPixmap &p, int m, int (*v)(int, int, int, int)) : XsPixmap(p), max(m), _image(NULL) {
    trans(v);
}

XsPixmapTrans::~XsPixmapTrans(void) {
    delete [] _image;
    _image = NULL;
}

void XsPixmapTrans::trans(int (*f)(int, int, int, int)) {

    // ǥեȤδؿ
    if (!f) f = defaultfunc;
    
    // ʬβ
    delete [] _image;
    _image = new XsPixmap[max];

    // ٥˱ƽ
    for (int l = 0;l < max;l ++) {

	// 	
	XsPixmap &i = _image[l];

	// ԥåޥåפʣ	
	i.create(*this);

	// ޥ	
	i.addMask();

	// ᡼μ
	XImage *xdp = XGetImage(display, pixmap(),
				0, 0, i.size().x, i.size().y,
				AllPlanes, ZPixmap);
	XImage *xdm = XGetImage(display, i.mask(),
				0, 0, i.size().x, i.size().y,
				AllPlanes, ZPixmap);

	// ؿѤƷȴ
	ForRel (v,zero,size()) {
	    if (!f(v.x,v.y,l,max)) {
		XPutPixel(xdp, v.x, v.y, 0);
		XPutPixel(xdm, v.x, v.y, 0);
	    }
	}
    
	// ᡼ȿ
	XPutImage(display, i.pixmap(),
		  gcCopy, xdp, 0, 0,
		  0, 0, size().x, size().y);
	XPutImage(display, i.mask(),
		  gc1Copy, xdm, 0, 0,
		  0, 0, size().x, size().y);
    }

    XFlush(display);
}

const XsPixmap &XsPixmapTrans::image(const int n) const {
    int m = (n < 0) ? 0 : (max <= n) ? max - 1 : n;
    return _image[m];
}
