#ifndef XsWindow_H
#define XsWindow_H

//
// XsWindow.H
//

// إå
#include <String.h>

#include <XsBase.H>
#include <List.H>

/* #####################################################################
   class XsWindow
   ##################################################################### */

// 饹
class XsWindow : public XsBase {

  public:
    XsWindow(const Vector &,const String &name = "NoName",int = 1);
    ~XsWindow(void);
    operator Window(void) const;
    void state(int);
  private:
    int _state;
    Window _window;
};

/* #####################################################################
   class XsMultiWindow
   ##################################################################### */

// 饹
class XsMultiWindow : public XsBase {

public:
    XsMultiWindow(const Vector &,const String &name = "NoName",int = 1);
    ~XsMultiWindow(void);
    Window operator [](int);
    void state(int);
private:
    int _state;
    Window _window;
    AssocList <int,Window> list;

public:
    void create(int,const Vector &,const Vector &);
    void destroy(int);
};

#endif
